%Vagelis Papalexakis, 2013-2014
%School of Computer Science, Carnegie Mellon University
%Demo of the Turbo-SMT Algorithm from SDM2014 using synthetic

clear all;close all;clc


% load('/BrainQ/X.mat','X3');X = X3;
I = 10^5;
X = sptenrand([I I I],1000);

Y = sprandn(I,I/100,0.1);
sz = size(X);
I = sz(1); J = sz(2); K = sz(3);

s = 100;
sample_factor = [s s s];

nonneg = 0;
F = 5;

mat{1} = Y; mat{2} = []; mat{3} = [];

%run CMTF-OPT
Fac = cmtf_opt_wrapper(X,Y,F);

%run CMTF-ALS (this is the improved version, as introduced in the paper)
[A B C outmatrices cost] = fastCMTF_sparse(X,mat,F);

repetitions = 4;
matlabpool open
%run Turbo-SMT with CMTF-OPT
[A1 B1 C1 outmatrices1 lambda1 sigma1] = TurboSMT_parallel(X,mat,F,sample_factor,repetitions,nonneg);D1 = outmatrices1{1};
%run Turbo-SMT with CMTF-ALS
[A2 B2 C2 outmatrices2 lambda2 sigma2] = TurboSMT_als_parallel(X,mat,F,sample_factor,repetitions,nonneg);D2 = outmatrices2{1};
matlabpool close